Ctxpopup
Elementary

Context popup widget. More...

## Topics

| Elm_Ctxpopup_Item_Group
| Elementary context popup item class.

## Macros

#define | ELM_CTXPOPUP_CLASS elm_ctxpopup_class_get()
| Elementary context popup class.
#define | ELM_CTXPOPUP_EVENT_DISMISSED (&(_ELM_CTXPOPUP_EVENT_DISMISSED))
| Called when context popup was dismissed.
#define | ELM_CTXPOPUP_EVENT_GEOMETRY_UPDATE (&(_ELM_CTXPOPUP_EVENT_GEOMETRY_UPDATE))
| Called when context popup geometry was updated.

## Enumerations

enum | Elm_Ctxpopup_Direction { ELM_CTXPOPUP_DIRECTION_DOWN = 0 , ELM_CTXPOPUP_DIRECTION_RIGHT , ELM_CTXPOPUP_DIRECTION_LEFT , ELM_CTXPOPUP_DIRECTION_UP , ELM_CTXPOPUP_DIRECTION_UNKNOWN }
| Direction in which to show the popup. More...
enum | Elm_Ctxpopup_Direction { ELM_CTXPOPUP_DIRECTION_DOWN = 0 , ELM_CTXPOPUP_DIRECTION_RIGHT , ELM_CTXPOPUP_DIRECTION_LEFT , ELM_CTXPOPUP_DIRECTION_UP , ELM_CTXPOPUP_DIRECTION_UNKNOWN }
| Direction in which to show the popup. More...

## Functions

Evas_Object * | elm_ctxpopup_add (Evas_Object *parent)
| Add a new Ctxpopup object to the parent.
EOAPI Elm_Widget_Item * | elm_obj_ctxpopup_selected_item_get (const Eo *obj)
| Get the selected item in the widget.
EOAPI Elm_Widget_Item * | elm_obj_ctxpopup_first_item_get (const Eo *obj)
| Get the first item in the widget.
EOAPI Elm_Widget_Item * | elm_obj_ctxpopup_last_item_get (const Eo *obj)
| Get the last item in the widget.
EOAPI const Eina_List * | elm_obj_ctxpopup_items_get (const Eo *obj)
| Returns a list of the widget item.
EOAPI void | elm_obj_ctxpopup_horizontal_set (Eo *obj, Eina_Bool horizontal)
| Change the ctxpopup's orientation to horizontal or vertical.
EOAPI Eina_Bool | elm_obj_ctxpopup_horizontal_get (const Eo *obj)
| Get the value of current ctxpopup object's orientation.
EOAPI void | elm_obj_ctxpopup_auto_hide_disabled_set (Eo *obj, Eina_Bool disabled)
| Set ctxpopup auto hide mode triggered by ctxpopup policy.
EOAPI Eina_Bool | elm_obj_ctxpopup_auto_hide_disabled_get (const Eo *obj)
| Get ctxpopup auto hide mode triggered by ctxpopup policy.
EOAPI void | elm_obj_ctxpopup_hover_parent_set (Eo *obj, Efl_Canvas_Object *parent)
| Set the Ctxpopup's parent.
EOAPI Efl_Canvas_Object * | elm_obj_ctxpopup_hover_parent_get (const Eo *obj)
| Get the Ctxpopup's parent.
EOAPI void | elm_obj_ctxpopup_direction_priority_set (Eo *obj, Elm_Ctxpopup_Direction first, Elm_Ctxpopup_Direction second, Elm_Ctxpopup_Direction third, Elm_Ctxpopup_Direction fourth)
| Set the direction priority of a ctxpopup.
EOAPI void | elm_obj_ctxpopup_direction_priority_get (const Eo *obj, Elm_Ctxpopup_Direction *first, Elm_Ctxpopup_Direction *second, Elm_Ctxpopup_Direction *third, Elm_Ctxpopup_Direction *fourth)
| Get the direction priority of a ctxpopup.
EOAPI Elm_Ctxpopup_Direction | elm_obj_ctxpopup_direction_get (const Eo *obj)
| Get the current direction of a ctxpopup.
EOAPI void | elm_obj_ctxpopup_dismiss (Eo *obj)
| Dismiss a ctxpopup object.
EOAPI void | elm_obj_ctxpopup_clear (Eo *obj)
| Clear all items in the given ctxpopup object.
EOAPI Elm_Widget_Item * | elm_obj_ctxpopup_item_insert_before (Eo *obj, Elm_Widget_Item *before, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Insert a new item to a ctxpopup object before item `before`.
EOAPI Elm_Widget_Item * | elm_obj_ctxpopup_item_insert_after (Eo *obj, Elm_Widget_Item *after, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Insert a new item to a ctxpopup object after item `after`.
EOAPI Elm_Widget_Item * | elm_obj_ctxpopup_item_append (Eo *obj, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Add a new item to a ctxpopup object.
EOAPI Elm_Widget_Item * | elm_obj_ctxpopup_item_prepend (Eo *obj, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Prepend a new item to a ctxpopup object.
Elm_Widget_Item * | elm_ctxpopup_selected_item_get (const Elm_Ctxpopup *obj)
| Get the selected item in the widget.
Elm_Widget_Item * | elm_ctxpopup_first_item_get (const Elm_Ctxpopup *obj)
| Get the first item in the widget.
Elm_Widget_Item * | elm_ctxpopup_last_item_get (const Elm_Ctxpopup *obj)
| Get the last item in the widget.
const Eina_List * | elm_ctxpopup_items_get (const Elm_Ctxpopup *obj)
| Returns a list of the widget item.
void | elm_ctxpopup_horizontal_set (Elm_Ctxpopup *obj, Eina_Bool horizontal)
| Change the ctxpopup's orientation to horizontal or vertical.
Eina_Bool | elm_ctxpopup_horizontal_get (const Elm_Ctxpopup *obj)
| Get the value of current ctxpopup object's orientation.
void | elm_ctxpopup_auto_hide_disabled_set (Elm_Ctxpopup *obj, Eina_Bool disabled)
| Set ctxpopup auto hide mode triggered by ctxpopup policy.
Eina_Bool | elm_ctxpopup_auto_hide_disabled_get (const Elm_Ctxpopup *obj)
| Get ctxpopup auto hide mode triggered by ctxpopup policy.
void | elm_ctxpopup_hover_parent_set (Elm_Ctxpopup *obj, Efl_Canvas_Object *parent)
| Set the Ctxpopup's parent.
Efl_Canvas_Object * | elm_ctxpopup_hover_parent_get (const Elm_Ctxpopup *obj)
| Get the Ctxpopup's parent.
void | elm_ctxpopup_direction_priority_set (Elm_Ctxpopup *obj, Elm_Ctxpopup_Direction first, Elm_Ctxpopup_Direction second, Elm_Ctxpopup_Direction third, Elm_Ctxpopup_Direction fourth)
| Set the direction priority of a ctxpopup.
void | elm_ctxpopup_direction_priority_get (const Elm_Ctxpopup *obj, Elm_Ctxpopup_Direction *first, Elm_Ctxpopup_Direction *second, Elm_Ctxpopup_Direction *third, Elm_Ctxpopup_Direction *fourth)
| Get the direction priority of a ctxpopup.
Elm_Ctxpopup_Direction | elm_ctxpopup_direction_get (const Elm_Ctxpopup *obj)
| Get the current direction of a ctxpopup.
void | elm_ctxpopup_dismiss (Elm_Ctxpopup *obj)
| Dismiss a ctxpopup object.
void | elm_ctxpopup_clear (Elm_Ctxpopup *obj)
| Clear all items in the given ctxpopup object.
Elm_Widget_Item * | elm_ctxpopup_item_insert_before (Elm_Ctxpopup *obj, Elm_Widget_Item *before, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Insert a new item to a ctxpopup object before item `before`.
Elm_Widget_Item * | elm_ctxpopup_item_insert_after (Elm_Ctxpopup *obj, Elm_Widget_Item *after, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Insert a new item to a ctxpopup object after item `after`.
Elm_Widget_Item * | elm_ctxpopup_item_append (Elm_Ctxpopup *obj, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Add a new item to a ctxpopup object.
Elm_Widget_Item * | elm_ctxpopup_item_prepend (Elm_Ctxpopup *obj, const char *label, Efl_Canvas_Object *icon, Evas_Smart_Cb func, const void *data)
| Prepend a new item to a ctxpopup object.

## Detailed Description

Context popup widget.

A ctxpopup is a widget that, when shown, pops up a list of items. It automatically chooses an area inside its parent object's view (set via elm_ctxpopup_add() and elm_ctxpopup_hover_parent_set()) to optimally fit into it. In the default theme, it will also point an arrow to it's top left position at the time one shows it. Ctxpopup items have a label and/or an icon. It is intended for a small number of items (hence the use of list, not genlist).

This widget inherits from the Layout one, so that all the functions acting on it also work for context popup objects (since 1.8).

This widget emits the following signals, besides the ones sent from Layout :

- `"dismissed"` - This is called when 1. the outside of ctxpopup was clicked or 2. its parent area is changed or 3. the language is changed and also when

1. the parent object is resized due to the window rotation. Then ctxpopup is dismissed.

- `"language,changed"` - This is called when the program's language is changed.
- `"focused"` - When the ctxpopup has received focus. (since 1.8)
- `"unfocused"` - When the ctxpopup has lost focus. (since 1.8)
- `"geometry,update"` - When the ctxpopup geometry is updated. This smart event passes the ctxpopup geometry information with the given event_info argument which type is Evas_Coord_Rectangle. (since 1.18)

Default content parts of the ctxpopup widget that you can use for are:

- "default" - A content of the ctxpopup

Default content parts of the ctxpopup items that you can use for are:

- "icon" - An icon in the title area

Default text parts of the ctxpopup items that you can use for are:

- "default" - A title label in the title area

Supported elm_object common APIs.

- elm_object_disabled_set
- elm_object_disabled_get

Supported elm_object_item common APIs.

- elm_object_item_del
- elm_object_item_disabled_set
- elm_object_item_disabled_get
- elm_object_item_part_text_set
- elm_object_item_part_text_get
- elm_object_item_part_content_set
- elm_object_item_part_content_get
- elm_object_item_signal_emit
- elm_object_item_focus_set
- elm_object_item_focus_get

Ctxpopup example shows the usage of a good deal of the API.

## Macro Definition Documentation

## ELM_CTXPOPUP_EVENT_GEOMETRY_UPDATE

#define ELM_CTXPOPUP_EVENT_GEOMETRY_UPDATE (&(_ELM_CTXPOPUP_EVENT_GEOMETRY_UPDATE))

Called when context popup geometry was updated.

Returns
  const Eina_Rect *

## Enumeration Type Documentation

## Elm_Ctxpopup_Direction [1/2]

enum Elm_Ctxpopup_Direction

Direction in which to show the popup.

Enumerator
ELM_CTXPOPUP_DIRECTION_DOWN | Ctxpopup show appear below clicked area.
ELM_CTXPOPUP_DIRECTION_RIGHT | Ctxpopup show appear to the right of the clicked area.
ELM_CTXPOPUP_DIRECTION_LEFT | Ctxpopup show appear to the left of the clicked area.
ELM_CTXPOPUP_DIRECTION_UP | Ctxpopup show appear above the clicked area.
ELM_CTXPOPUP_DIRECTION_UNKNOWN | Ctxpopup does not determine it's direction yet.

## Elm_Ctxpopup_Direction [2/2]

enum Elm_Ctxpopup_Direction

Direction in which to show the popup.

Enumerator
ELM_CTXPOPUP_DIRECTION_DOWN | Ctxpopup show appear below clicked area.
ELM_CTXPOPUP_DIRECTION_RIGHT | Ctxpopup show appear to the right of the clicked area.
ELM_CTXPOPUP_DIRECTION_LEFT | Ctxpopup show appear to the left of the clicked area.
ELM_CTXPOPUP_DIRECTION_UP | Ctxpopup show appear above the clicked area.
ELM_CTXPOPUP_DIRECTION_UNKNOWN | Ctxpopup does not determine it's direction yet.

## Function Documentation

## elm_ctxpopup_add()

Evas_Object * elm_ctxpopup_add | ( | Evas_Object * | parent | ) |

Add a new Ctxpopup object to the parent.

Parameters

  parent | Parent object

Returns
  New object or `NULL`, if it cannot be created

References EINA_SAFETY_ON_NULL_RETURN_VAL, and EINA_TRUE.

## elm_obj_ctxpopup_selected_item_get()

EOAPI Elm_Widget_Item * elm_obj_ctxpopup_selected_item_get | ( | const Eo * | obj | ) |

Get the selected item in the widget.

Parameters

  [in] | obj | The object.

Returns
  The selected item or `null`.

Referenced by elm_ctxpopup_selected_item_get().

## elm_obj_ctxpopup_first_item_get()

EOAPI Elm_Widget_Item * elm_obj_ctxpopup_first_item_get | ( | const Eo * | obj | ) |

Get the first item in the widget.

Parameters

  [in] | obj | The object.

Returns
  The first item or `null`.

Referenced by elm_ctxpopup_first_item_get().

## elm_obj_ctxpopup_last_item_get()

EOAPI Elm_Widget_Item * elm_obj_ctxpopup_last_item_get | ( | const Eo * | obj | ) |

Get the last item in the widget.

Parameters

  [in] | obj | The object.

Returns
  The last item or `null`.

Referenced by elm_ctxpopup_last_item_get().

## elm_obj_ctxpopup_items_get()

EOAPI const Eina_List * elm_obj_ctxpopup_items_get | ( | const Eo * | obj | ) |

Returns a list of the widget item.

Parameters

  [in] | obj | The object.

Returns
  const list to widget items

Referenced by elm_ctxpopup_items_get().

## elm_obj_ctxpopup_horizontal_set()

EOAPI void elm_obj_ctxpopup_horizontal_set | ( | Eo * | obj,
|  | Eina_Bool | horizontal )

Change the ctxpopup's orientation to horizontal or vertical.

Parameters

  [in] | obj | The object.
  [in] | horizontal | `true` for horizontal mode, `false` for vertical.

Referenced by elm_ctxpopup_horizontal_set().

## elm_obj_ctxpopup_horizontal_get()

EOAPI Eina_Bool elm_obj_ctxpopup_horizontal_get | ( | const Eo * | obj | ) |

Get the value of current ctxpopup object's orientation.

See also elm_obj_ctxpopup_horizontal_set.

Parameters

  [in] | obj | The object.

Returns
  `true` for horizontal mode, `false` for vertical.

Referenced by elm_ctxpopup_horizontal_get().

## elm_obj_ctxpopup_auto_hide_disabled_set()

EOAPI void elm_obj_ctxpopup_auto_hide_disabled_set | ( | Eo * | obj,
|  | Eina_Bool | disabled )

Set ctxpopup auto hide mode triggered by ctxpopup policy.

Use this function when user wants ctxpopup not to hide automatically. By default, ctxpopup is dismissed whenever mouse clicked its background area, language is changed, and its parent geometry is updated(changed). Not to hide ctxpopup automatically, disable auto hide function by calling this API, then ctxpopup won't be dismissed in those scenarios.

Default value of disabled is `false`.

See also elm_obj_ctxpopup_auto_hide_disabled_get.

Parameters

  [in] | obj | The object.
  [in] | disabled | Auto hide enable/disable.

Since
  1.9

Referenced by elm_ctxpopup_auto_hide_disabled_set().

## elm_obj_ctxpopup_auto_hide_disabled_get()

EOAPI Eina_Bool elm_obj_ctxpopup_auto_hide_disabled_get | ( | const Eo * | obj | ) |

Get ctxpopup auto hide mode triggered by ctxpopup policy.

See also elm_obj_ctxpopup_auto_hide_disabled_set for more information.

Parameters

  [in] | obj | The object.

Returns
  Auto hide enable/disable.

Since
  1.9

Referenced by elm_ctxpopup_auto_hide_disabled_get().

## elm_obj_ctxpopup_hover_parent_set()

EOAPI void elm_obj_ctxpopup_hover_parent_set | ( | Eo * | obj,
|  | Efl_Canvas_Object * | parent )

Set the Ctxpopup's parent.

Set the parent object.

Note
  elm_ctxpopup_add will automatically call this function with its `parent` argument.

See also elm_ctxpopup_add, elm_hover_parent_set.

Parameters

  [in] | obj | The object.
  [in] | parent | The parent to use.

Referenced by elm_ctxpopup_hover_parent_set().

## elm_obj_ctxpopup_hover_parent_get()

EOAPI Efl_Canvas_Object * elm_obj_ctxpopup_hover_parent_get | ( | const Eo * | obj | ) |

Get the Ctxpopup's parent.

See also elm_obj_ctxpopup_hover_parent_set for more information

Parameters

  [in] | obj | The object.

Returns
  The parent to use.

Referenced by elm_ctxpopup_hover_parent_get().

## elm_obj_ctxpopup_direction_priority_set()

EOAPI void elm_obj_ctxpopup_direction_priority_set | ( | Eo * | obj,
|  | Elm_Ctxpopup_Direction | first,
|  | Elm_Ctxpopup_Direction | second,
|  | Elm_Ctxpopup_Direction | third,
|  | Elm_Ctxpopup_Direction | fourth )

Set the direction priority of a ctxpopup.

This functions gives a chance to user to set the priority of ctxpopup showing direction. This doesn't guarantee the ctxpopup will appear in the requested direction.

See also Elm_Ctxpopup_Direction.

Parameters

  [in] | obj | The object.
  [in] | first | 1st priority of direction
  [in] | second | 2nd priority of direction
  [in] | third | 3th priority of direction
  [in] | fourth | 4th priority of direction

Referenced by elm_ctxpopup_direction_priority_set().

## elm_obj_ctxpopup_direction_priority_get()

EOAPI void elm_obj_ctxpopup_direction_priority_get | ( | const Eo * | obj,
|  | Elm_Ctxpopup_Direction * | first,
|  | Elm_Ctxpopup_Direction * | second,
|  | Elm_Ctxpopup_Direction * | third,
|  | Elm_Ctxpopup_Direction * | fourth )

Get the direction priority of a ctxpopup.

See also elm_obj_ctxpopup_direction_priority_set for more information.

Parameters

  [in] | obj | The object.
  [out] | first | 1st priority of direction
  [out] | second | 2nd priority of direction
  [out] | third | 3th priority of direction
  [out] | fourth | 4th priority of direction

Referenced by elm_ctxpopup_direction_priority_get().

## elm_obj_ctxpopup_direction_get()

EOAPI Elm_Ctxpopup_Direction elm_obj_ctxpopup_direction_get | ( | const Eo * | obj | ) |

Get the current direction of a ctxpopup.

Warning
  Once the ctxpopup showed up, the direction would be determined

Parameters

  [in] | obj | The object.

Returns
  Direction

Referenced by elm_ctxpopup_direction_get().

## elm_obj_ctxpopup_dismiss()

EOAPI void elm_obj_ctxpopup_dismiss | ( | Eo * | obj | ) |

Dismiss a ctxpopup object.

Use this function to simulate clicking outside of the ctxpopup to dismiss it. In this way, the ctxpopup will be hidden and the "clicked" signal will be emitted.

Parameters

  [in] | obj | The object.

Referenced by elm_ctxpopup_dismiss().

## elm_obj_ctxpopup_item_insert_before()

EOAPI Elm_Widget_Item * elm_obj_ctxpopup_item_insert_before | ( | Eo * | obj,
|  | Elm_Widget_Item * | before,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Insert a new item to a ctxpopup object before item `before`.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | before | The ctxpopup item to insert before.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

Since
  1.21

Referenced by elm_ctxpopup_item_insert_before().

## elm_obj_ctxpopup_item_insert_after()

EOAPI Elm_Widget_Item * elm_obj_ctxpopup_item_insert_after | ( | Eo * | obj,
|  | Elm_Widget_Item * | after,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Insert a new item to a ctxpopup object after item `after`.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | after | The ctxpopup item to insert after.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

Since
  1.21

Referenced by elm_ctxpopup_item_insert_after().

## elm_obj_ctxpopup_item_append()

EOAPI Elm_Widget_Item * elm_obj_ctxpopup_item_append | ( | Eo * | obj,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Add a new item to a ctxpopup object.

Warning:Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

Referenced by elm_ctxpopup_item_append().

## elm_obj_ctxpopup_item_prepend()

EOAPI Elm_Widget_Item * elm_obj_ctxpopup_item_prepend | ( | Eo * | obj,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Prepend a new item to a ctxpopup object.

Warning
  Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

Since
  1.11

Referenced by elm_ctxpopup_item_prepend().

## elm_ctxpopup_selected_item_get()

Elm_Widget_Item * elm_ctxpopup_selected_item_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the selected item in the widget.

Parameters

  [in] | obj | The object.

Returns
  The selected item or `null`.

References elm_obj_ctxpopup_selected_item_get().

## elm_ctxpopup_first_item_get()

Elm_Widget_Item * elm_ctxpopup_first_item_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the first item in the widget.

Parameters

  [in] | obj | The object.

Returns
  The first item or `null`.

References elm_obj_ctxpopup_first_item_get().

## elm_ctxpopup_last_item_get()

Elm_Widget_Item * elm_ctxpopup_last_item_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the last item in the widget.

Parameters

  [in] | obj | The object.

Returns
  The last item or `null`.

References elm_obj_ctxpopup_last_item_get().

## elm_ctxpopup_items_get()

const Eina_List * elm_ctxpopup_items_get | ( | const Elm_Ctxpopup * | obj | ) |

Returns a list of the widget item.

Parameters

  [in] | obj | The object.

Returns
  const list to widget items

References elm_obj_ctxpopup_items_get().

## elm_ctxpopup_horizontal_set()

void elm_ctxpopup_horizontal_set | ( | Elm_Ctxpopup * | obj,
|  | Eina_Bool | horizontal )

Change the ctxpopup's orientation to horizontal or vertical.

Parameters

  [in] | obj | The object.
  [in] | horizontal | `true` for horizontal mode, `false` for vertical.

References elm_obj_ctxpopup_horizontal_set().

## elm_ctxpopup_horizontal_get()

Eina_Bool elm_ctxpopup_horizontal_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the value of current ctxpopup object's orientation.

See also elm_ctxpopup_horizontal_set.

Parameters

  [in] | obj | The object.

Returns
  `true` for horizontal mode, `false` for vertical.

References elm_obj_ctxpopup_horizontal_get().

## elm_ctxpopup_auto_hide_disabled_set()

void elm_ctxpopup_auto_hide_disabled_set | ( | Elm_Ctxpopup * | obj,
|  | Eina_Bool | disabled )

Set ctxpopup auto hide mode triggered by ctxpopup policy.

Use this function when user wants ctxpopup not to hide automatically. By default, ctxpopup is dismissed whenever mouse clicked its background area, language is changed, and its parent geometry is updated(changed). Not to hide ctxpopup automatically, disable auto hide function by calling this API, then ctxpopup won't be dismissed in those scenarios.

Default value of disabled is `false`.

See also elm_ctxpopup_auto_hide_disabled_get.

Parameters

  [in] | obj | The object.
  [in] | disabled | Auto hide enable/disable.

Since
  1.9

References elm_obj_ctxpopup_auto_hide_disabled_set().

## elm_ctxpopup_auto_hide_disabled_get()

Eina_Bool elm_ctxpopup_auto_hide_disabled_get | ( | const Elm_Ctxpopup * | obj | ) |

Get ctxpopup auto hide mode triggered by ctxpopup policy.

See also elm_ctxpopup_auto_hide_disabled_set for more information.

Parameters

  [in] | obj | The object.

Returns
  Auto hide enable/disable.

Since
  1.9

References elm_obj_ctxpopup_auto_hide_disabled_get().

## elm_ctxpopup_hover_parent_set()

void elm_ctxpopup_hover_parent_set | ( | Elm_Ctxpopup * | obj,
|  | Efl_Canvas_Object * | parent )

Set the Ctxpopup's parent.

Set the parent object.

Note
  elm_ctxpopup_add will automatically call this function with its `parent` argument.

See also elm_ctxpopup_add, elm_hover_parent_set.

Parameters

  [in] | obj | The object.
  [in] | parent | The parent to use.

References elm_obj_ctxpopup_hover_parent_set().

## elm_ctxpopup_hover_parent_get()

Efl_Canvas_Object * elm_ctxpopup_hover_parent_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the Ctxpopup's parent.

See also elm_ctxpopup_hover_parent_set for more information

Parameters

  [in] | obj | The object.

Returns
  The parent to use.

References elm_obj_ctxpopup_hover_parent_get().

## elm_ctxpopup_direction_priority_set()

void elm_ctxpopup_direction_priority_set | ( | Elm_Ctxpopup * | obj,
|  | Elm_Ctxpopup_Direction | first,
|  | Elm_Ctxpopup_Direction | second,
|  | Elm_Ctxpopup_Direction | third,
|  | Elm_Ctxpopup_Direction | fourth )

Set the direction priority of a ctxpopup.

This functions gives a chance to user to set the priority of ctxpopup showing direction. This doesn't guarantee the ctxpopup will appear in the requested direction.

See also Elm_Ctxpopup_Direction.

Parameters

  [in] | obj | The object.
  [in] | first | 1st priority of direction
  [in] | second | 2nd priority of direction
  [in] | third | 3th priority of direction
  [in] | fourth | 4th priority of direction

References elm_obj_ctxpopup_direction_priority_set().

## elm_ctxpopup_direction_priority_get()

void elm_ctxpopup_direction_priority_get | ( | const Elm_Ctxpopup * | obj,
|  | Elm_Ctxpopup_Direction * | first,
|  | Elm_Ctxpopup_Direction * | second,
|  | Elm_Ctxpopup_Direction * | third,
|  | Elm_Ctxpopup_Direction * | fourth )

Get the direction priority of a ctxpopup.

See also elm_ctxpopup_direction_priority_set for more information.

Parameters

  [in] | obj | The object.
  [out] | first | 1st priority of direction
  [out] | second | 2nd priority of direction
  [out] | third | 3th priority of direction
  [out] | fourth | 4th priority of direction

References elm_obj_ctxpopup_direction_priority_get().

## elm_ctxpopup_direction_get()

Elm_Ctxpopup_Direction elm_ctxpopup_direction_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the current direction of a ctxpopup.

Warning
  Once the ctxpopup showed up, the direction would be determined

Parameters

  [in] | obj | The object.

Returns
  Direction

References elm_obj_ctxpopup_direction_get().

## elm_ctxpopup_dismiss()

void elm_ctxpopup_dismiss | ( | Elm_Ctxpopup * | obj | ) |

Dismiss a ctxpopup object.

Use this function to simulate clicking outside of the ctxpopup to dismiss it. In this way, the ctxpopup will be hidden and the "clicked" signal will be emitted.

Parameters

  [in] | obj | The object.

References elm_obj_ctxpopup_dismiss().

## elm_ctxpopup_item_insert_before()

Elm_Widget_Item * elm_ctxpopup_item_insert_before | ( | Elm_Ctxpopup * | obj,
|  | Elm_Widget_Item * | before,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Insert a new item to a ctxpopup object before item `before`.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | before | The ctxpopup item to insert before.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

Since
  1.21

References elm_obj_ctxpopup_item_insert_before().

## elm_ctxpopup_item_insert_after()

Elm_Widget_Item * elm_ctxpopup_item_insert_after | ( | Elm_Ctxpopup * | obj,
|  | Elm_Widget_Item * | after,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Insert a new item to a ctxpopup object after item `after`.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | after | The ctxpopup item to insert after.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

Since
  1.21

References elm_obj_ctxpopup_item_insert_after().

## elm_ctxpopup_item_append()

Elm_Widget_Item * elm_ctxpopup_item_append | ( | Elm_Ctxpopup * | obj,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Add a new item to a ctxpopup object.

Warning:Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

References elm_obj_ctxpopup_item_append().

## elm_ctxpopup_item_prepend()

Elm_Widget_Item * elm_ctxpopup_item_prepend | ( | Elm_Ctxpopup * | obj,
|  | const char * | label,
|  | Efl_Canvas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

Prepend a new item to a ctxpopup object.

Warning
  Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also elm_object_content_set.

Parameters

  [in] | obj | The object.
  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Returns
  A handle to the item added or `null`, on errors.

Since
  1.11

References elm_obj_ctxpopup_item_prepend().